package operation

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/web"
	kit "shylinux.com/x/toolkits"

	"2025-dev.shylinux.com/x/20250215-cluster/src/travel"
	"shylinux.com/x/operation/src/operation/model"
)

type cluster struct {
	Table
	travel      travel.Travel
	order       string `data:"1"`
	fields      string `data:"title,content,space,total,stock,price"`
	payfor      string `name:"payfor" help:"购买" style:"notice" role:"leader"`
	scanService string `name:"scanService" help:"扫描"`
	modify      string `name:"modify title content price" style:"danger"`
}

func (s cluster) Scan(m *ice.Message, arg ...string) {
	m.Cmd(s.travel, s.travel.Concurrent, "2025-dev.shylinux.com/x/20250215-cluster", "web.chat.dev.cluster.travel").Table(func(value ice.Maps) {
		s.InsertIfNeed(m, web.SPACE, value[web.SPACE])
	})
	m.ProcessRefresh()
}
func (s cluster) List(m *ice.Message, arg ...string) {
	if s.Select(m); m.Length() == 0 {
		if m.IsTech() {
			m.EchoInfoButton("请扫描集群", s.Scan)
		} else {
			m.Echo("请联系平台管理员部署集群").Action()
		}
	} else {
		if m.Display(""); m.IsTech() {
			m.Table(func(value ice.Maps) {
				if kit.Int(value[model.STOCK]) > 0 {
					m.PushButton(s.Payfor, s.ScanService, s.Modify)
				} else {
					m.PushButton(s.ScanService, s.Modify)
				}
			}).Action(s.Scan)
		} else if s.IsLeader(m) {
			m.Table(func(value ice.Maps) {
				if kit.Int(value[model.STOCK]) > 0 {
					m.PushButton(s.Payfor)
				} else {
					m.PushButton()
				}
			}).Action()
		} else {
			m.PushAction().Action()
		}
	}
}
func (s cluster) Payfor(m *ice.Message, arg ...string) {
	m.Option(model.CLUSTER_UID, m.Option(model.UID))
	m.Cmdy(gateway{}, s.Payfor, arg)
}
func (s cluster) ScanService(m *ice.Message, arg ...string) {
	m.Option(model.CLUSTER_UID, m.Option(model.UID))
	m.Cmdy(gateway{}, s.Scan, arg)
	s.Update(m, m.AppendSimple(model.TOTAL, model.STOCK), m.OptionSimple(model.UID)...)
	m.ProcessRefresh()
}
func (s cluster) Modify(m *ice.Message, arg ...string) {
	s.Update(m, s.TransPrice(m, arg), m.OptionSimple(model.UID)...)
}

func init() { ice.TeamCtxCmd(cluster{}) }
