package operation

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/ctx"
	"shylinux.com/x/icebergs/base/mdb"
	"shylinux.com/x/icebergs/base/web"
	"shylinux.com/x/operation/src/operation/model"
	kit "shylinux.com/x/toolkits"
)

type product struct {
	Table
	cluster cluster
	gateway gateway
	project project
	order   string `data:"4"`
	fields  string `data:"index,name,project_uid"`
	open    string `name:"open" role:"void"`
}

func (s product) List(m *ice.Message, arg ...string) {
	s.ValueList(m, arg).PushAction(s.Open).Display("")
	s.Fields(m, model.UID, s.Keys(s.gateway, model.UID)).SelectJoin(m, s.project, s.Keys(s.gateway, model.UID))
	s.Fields(m, model.UID, s.KeyAS(s.gateway, model.TITLE)).SelectJoin(m, s.gateway, s.Keys(s.gateway, model.TITLE))
}
func (s product) Open(m *ice.Message, arg ...string) {
	m.ProcessOpen(m.Options(ice.MSG_USERPOD, "").MergePodCmd(s.space(m.Spawn()), m.Option(ctx.INDEX)))
}

func init() { ice.TeamCtxCmd(product{}) }

func (s product) space(m *ice.Message, arg ...string) string {
	s.Tables(m, s.project, s.gateway, s.cluster).Fields(m, s.Key(s.project, mdb.NAME), s.KeyAS(s.gateway, web.SPACE), s.KeyAS(s.cluster, web.SPACE))
	s.Select(m, kit.Simple(s.Key(s, model.CLOUD_UID), m.Option(model.CLOUD_UID), s.Key(s, model.UID), m.Option(model.UID))...)
	return kit.Keys(m.Append(model.CLUSTER_SPACE), m.Append(model.GATEWAY_SPACE), m.Append(model.NAME))
}
